import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/index.ts";
import { processArgs } from '@contentlayer/core';
import { pipe, S, T } from '@contentlayer/utils/effect';
import { NotionRenderer } from '@notion-render/client';
import * as notion from '@notionhq/client';
import { fetchAllDocuments } from './fetchData/fetchAllDocuments.js';
import { provideSchema } from './schema/provideSchema.js';
import { flattendDatabaseTypeDef } from './schema/utils/flattenDatabaseTypeDef.js';
import { NotionClient, NotionRenderer as NotionRendererTag } from './services.js';
export * from './schema/types/database.js';
export const makeSource = async (args) => {
    const { options, extensions, restArgs: { databaseTypes, ...rest }, } = await processArgs(args);
    const databaseTypeDefs = (Array.isArray(databaseTypes) ? databaseTypes : Object.values(databaseTypes)).map((_) => _.def());
    const client = rest.client ?? new notion.Client();
    const renderer = rest.renderer ?? new NotionRenderer({ client });
    return {
        type: 'notion',
        extensions,
        options,
        provideSchema: () => (T.provideService(NotionRendererTag)(renderer, fileName_1 + ":37:44")(T.provideService(NotionClient)(client, fileName_1 + ":36:39")(provideSchema({ databaseTypeDefs, options })))),
        fetchData: ({ schemaDef }) => (S.fromEffect((T.provideService(NotionRendererTag)(renderer, fileName_1 + ":50:48")(T.provideService(NotionClient)(client, fileName_1 + ":49:43")(T.either(fetchAllDocuments({
            databaseTypeDefs: databaseTypeDefs.map((databaseTypeDef) => flattendDatabaseTypeDef(databaseTypeDef)),
            schemaDef,
            options,
        }), fileName_1 + ":48:21")))))),
    };
};
//# sourceMappingURL=index.js.map