import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/schema/provideDocumentTypeDef.ts";
import { OT, pipe, T } from '@contentlayer/utils/effect';
import { NotionClient } from '../services.js';
import { provideFieldDef } from './provideFieldDef.js';
export const provideDocumentTypeDef = ({ databaseTypeDef, getDocumentTypeDef, options }) => (OT.withSpan('@contentlayer/source-notion/schema:provideDocumentTypeDef')(T.map_(T.chain_(T.service(NotionClient, fileName_1 + ":17:14"), (client) => (T.chain_(T.map_(T.tryPromise(() => client.databases.retrieve({ database_id: databaseTypeDef.databaseId }), fileName_1 + ":20:21"), ({ properties }) => Object.values(properties), fileName_1 + ":21:14"), (properties) => T.forEachPar_(properties, (property) => provideFieldDef({ databaseTypeDef, property, getDocumentTypeDef }), fileName_1 + ":23:24"), fileName_1 + ":22:16")), fileName_1 + ":18:12"), (fieldDefsChunk) => {
    const fieldDefs = [...fieldDefsChunk].filter((fd) => fd);
    if (databaseTypeDef.importContent !== false) {
        fieldDefs.push({
            name: options.fieldOptions.bodyFieldName,
            type: 'string',
            description: 'The page content',
            isRequired: false,
            isSystemField: true,
            default: undefined,
        });
    }
    const computedFields = Object.entries(databaseTypeDef.computedFields ?? {}).map(([name, computedField]) => ({
        description: computedField.description,
        type: computedField.type,
        name,
        // NOTE we need to flip the variance here (casting a core.Document to a LocalDocument)
        resolve: computedField.resolve,
    }));
    return {
        _tag: 'DocumentTypeDef',
        name: databaseTypeDef.name,
        description: databaseTypeDef.description,
        isSingleton: false,
        fieldDefs: fieldDefs,
        computedFields: computedFields,
        extensions: {},
    };
}, fileName_1 + ":27:10")));
//# sourceMappingURL=provideDocumentTypeDef.js.map